package slothLib.NLP;

/**
 * 形態素の並びを格納するクラス
 * <remarks>
 * 

 * <newpara>[2007-04-21][ohshima]作成</newpara>
 * </remarks>
 */
public interface IMorphologicalAnalyzerResult
{
	/**
	 * 格納している形態素の配列
	 */
	IMorpheme[] getMorphemes();
	
	///// <summary>
	///// インデクサ
	///// </summary>
	///// <param name="index">形態素の番号</param>
	///// <returns>index番目の形態素</returns>
	//IMorpheme this[int index]
	//{
	//    get;
	//}
	
	////IMorpheme[] ToArray();
	
	///// <summary>
	///// 格納されている形態素の数
	///// </summary>
	//int Count
	//{
	//    get;
	//}
	
	/**
	 * 各形態素のRawを配列にして返す
	 * @return Rawの配列
	 */
	String[] getRawArray();
	/**
	 * 各形態素のOriginalを配列にして返す
	 * @return Originalの配列
	 */
	String[] getOriginalArray();
	/**
	 * 各形態素のPOSを配列にして返す
	 * @return POSの配列
	 */
	String[] getPOSArray();
}
